/*!
* @file Skill.h
* @brief ゲーム中のスキルのプロトタイプ
* @date 2013/12/17
* @author Deskull
* 2013 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"
#include "GameElement.h"
#include "Creature.h"

class GameWorld;

namespace Deeangband
{

	/*!
	* @class Skill
	* @brief スキルのクラス
	*/
	class Skill : public GameElement
	{
	private:
		std::string name;
		std::string details;


		/*!
		* @brief クラスのシリアライズを設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
			}
		}

	public:

		/*! 
		* @brief Skillクラスコンストラクタ
		*/
		Skill::Skill(void);

		/*! 
		* @brief Skillクラスデストラクタ
		*/
		Skill::~Skill(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void Skill::WipeData(void);

		/*! 
		* @brief スキルの名称を返す
		* @return スキル名称
		*/
		std::string Skill::GetName(void);

		/*! 
		* @brief スキルの詳細を返す
		* @return スキル詳細
		*/
		std::string Skill::GetDetails(void);

		/*! 
		* @brief スキルランクを算出する
		* @param creaturePtr 算出したいクリーチャーのインスタンス参照ポインタ
		* @param tag 算出したいスキルのタグ
		* @return スキルランク
		*/
		static SKILL_RANK Skill::CalcSkillRank(Creature *creaturePtr, TAG tag);

	};

}

